/* This file was generated by ODB, object-relational mapping (ORM)
 * compiler for C++.
 */

CREATE TABLE "package_tests" (
  "tenant" TEXT NOT NULL,
  "name" CITEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "index" BIGINT NOT NULL,
  "dep_name" CITEXT NOT NULL,
  "dep_min_version_epoch" INTEGER NULL,
  "dep_min_version_canonical_upstream" TEXT NULL,
  "dep_min_version_canonical_release" TEXT NULL,
  "dep_min_version_revision" INTEGER NULL,
  "dep_min_version_upstream" TEXT NULL,
  "dep_min_version_release" TEXT NULL,
  "dep_max_version_epoch" INTEGER NULL,
  "dep_max_version_canonical_upstream" TEXT NULL,
  "dep_max_version_canonical_release" TEXT NULL,
  "dep_max_version_revision" INTEGER NULL,
  "dep_max_version_upstream" TEXT NULL,
  "dep_max_version_release" TEXT NULL,
  "dep_min_open" BOOLEAN NULL,
  "dep_max_open" BOOLEAN NULL,
  "dep_package_tenant" TEXT NULL,
  "dep_package_name" CITEXT NULL,
  "dep_package_version_epoch" INTEGER NULL,
  "dep_package_version_canonical_upstream" TEXT NULL,
  "dep_package_version_canonical_release" TEXT NULL COLLATE "C",
  "dep_package_version_revision" INTEGER NULL);

CREATE INDEX "package_tests_object_id_i"
  ON "package_tests" (
    "tenant",
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE INDEX "package_tests_index_i"
  ON "package_tests" ("index");

CREATE TABLE "package_examples" (
  "tenant" TEXT NOT NULL,
  "name" CITEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "index" BIGINT NOT NULL,
  "dep_name" CITEXT NOT NULL,
  "dep_min_version_epoch" INTEGER NULL,
  "dep_min_version_canonical_upstream" TEXT NULL,
  "dep_min_version_canonical_release" TEXT NULL,
  "dep_min_version_revision" INTEGER NULL,
  "dep_min_version_upstream" TEXT NULL,
  "dep_min_version_release" TEXT NULL,
  "dep_max_version_epoch" INTEGER NULL,
  "dep_max_version_canonical_upstream" TEXT NULL,
  "dep_max_version_canonical_release" TEXT NULL,
  "dep_max_version_revision" INTEGER NULL,
  "dep_max_version_upstream" TEXT NULL,
  "dep_max_version_release" TEXT NULL,
  "dep_min_open" BOOLEAN NULL,
  "dep_max_open" BOOLEAN NULL,
  "dep_package_tenant" TEXT NULL,
  "dep_package_name" CITEXT NULL,
  "dep_package_version_epoch" INTEGER NULL,
  "dep_package_version_canonical_upstream" TEXT NULL,
  "dep_package_version_canonical_release" TEXT NULL COLLATE "C",
  "dep_package_version_revision" INTEGER NULL);

CREATE INDEX "package_examples_object_id_i"
  ON "package_examples" (
    "tenant",
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE INDEX "package_examples_index_i"
  ON "package_examples" ("index");

CREATE TABLE "package_benchmarks" (
  "tenant" TEXT NOT NULL,
  "name" CITEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "index" BIGINT NOT NULL,
  "dep_name" CITEXT NOT NULL,
  "dep_min_version_epoch" INTEGER NULL,
  "dep_min_version_canonical_upstream" TEXT NULL,
  "dep_min_version_canonical_release" TEXT NULL,
  "dep_min_version_revision" INTEGER NULL,
  "dep_min_version_upstream" TEXT NULL,
  "dep_min_version_release" TEXT NULL,
  "dep_max_version_epoch" INTEGER NULL,
  "dep_max_version_canonical_upstream" TEXT NULL,
  "dep_max_version_canonical_release" TEXT NULL,
  "dep_max_version_revision" INTEGER NULL,
  "dep_max_version_upstream" TEXT NULL,
  "dep_max_version_release" TEXT NULL,
  "dep_min_open" BOOLEAN NULL,
  "dep_max_open" BOOLEAN NULL,
  "dep_package_tenant" TEXT NULL,
  "dep_package_name" CITEXT NULL,
  "dep_package_version_epoch" INTEGER NULL,
  "dep_package_version_canonical_upstream" TEXT NULL,
  "dep_package_version_canonical_release" TEXT NULL COLLATE "C",
  "dep_package_version_revision" INTEGER NULL);

CREATE INDEX "package_benchmarks_object_id_i"
  ON "package_benchmarks" (
    "tenant",
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE INDEX "package_benchmarks_index_i"
  ON "package_benchmarks" ("index");

ALTER TABLE "package_tests"
  ADD CONSTRAINT "tenant_fk"
    FOREIGN KEY ("tenant")
    REFERENCES "tenant" ("id")
    INITIALLY DEFERRED,
  ADD CONSTRAINT "object_id_fk"
    FOREIGN KEY ("tenant",
                 "name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("tenant",
                          "name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE,
  ADD CONSTRAINT "dep_package_tenant_fk"
    FOREIGN KEY ("dep_package_tenant")
    REFERENCES "tenant" ("id")
    INITIALLY DEFERRED,
  ADD CONSTRAINT "dep_package_fk"
    FOREIGN KEY ("dep_package_tenant",
                 "dep_package_name",
                 "dep_package_version_epoch",
                 "dep_package_version_canonical_upstream",
                 "dep_package_version_canonical_release",
                 "dep_package_version_revision")
    REFERENCES "package" ("tenant",
                          "name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    INITIALLY DEFERRED;

ALTER TABLE "package_examples"
  ADD CONSTRAINT "tenant_fk"
    FOREIGN KEY ("tenant")
    REFERENCES "tenant" ("id")
    INITIALLY DEFERRED,
  ADD CONSTRAINT "object_id_fk"
    FOREIGN KEY ("tenant",
                 "name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("tenant",
                          "name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE,
  ADD CONSTRAINT "dep_package_tenant_fk"
    FOREIGN KEY ("dep_package_tenant")
    REFERENCES "tenant" ("id")
    INITIALLY DEFERRED,
  ADD CONSTRAINT "dep_package_fk"
    FOREIGN KEY ("dep_package_tenant",
                 "dep_package_name",
                 "dep_package_version_epoch",
                 "dep_package_version_canonical_upstream",
                 "dep_package_version_canonical_release",
                 "dep_package_version_revision")
    REFERENCES "package" ("tenant",
                          "name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    INITIALLY DEFERRED;

ALTER TABLE "package_benchmarks"
  ADD CONSTRAINT "tenant_fk"
    FOREIGN KEY ("tenant")
    REFERENCES "tenant" ("id")
    INITIALLY DEFERRED,
  ADD CONSTRAINT "object_id_fk"
    FOREIGN KEY ("tenant",
                 "name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("tenant",
                          "name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE,
  ADD CONSTRAINT "dep_package_tenant_fk"
    FOREIGN KEY ("dep_package_tenant")
    REFERENCES "tenant" ("id")
    INITIALLY DEFERRED,
  ADD CONSTRAINT "dep_package_fk"
    FOREIGN KEY ("dep_package_tenant",
                 "dep_package_name",
                 "dep_package_version_epoch",
                 "dep_package_version_canonical_upstream",
                 "dep_package_version_canonical_release",
                 "dep_package_version_revision")
    REFERENCES "package" ("tenant",
                          "name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    INITIALLY DEFERRED;

UPDATE "schema_version"
  SET "version" = 17, "migration" = TRUE
  WHERE "name" = 'package';

